//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Application\CDX11Object.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CDX11OBJECT_H
#define CDX11OBJECT_H

#include <d3d11.h>
#include "CDX11Data.h"

namespace App
{
	class CDX11Object
	{
	public:
		CDX11Object();
		CDX11Object(const CDX11Object& other);
		virtual ~CDX11Object();

		inline DX11DATA*				DirectXData() const;
		void							DirectXData(DX11DATA* data);

	protected:
		DX11DATA*						m_pDX11Data;
		ID3D11Device*					m_pDev;
		ID3D11DeviceContext*			m_pDevCon;
	};

	// DirectX 11 data getter.
	inline DX11DATA* CDX11Object::DirectXData() const
	{
		return m_pDX11Data;
	}
};

#endif