//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Application\CWinData.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CWINDATA_H
#define CWINDATA_H

#include <Windows.h>
#include "..\Utilities\CMemoryFree.h"

namespace App
{
	// Structure for storing the data for a window created with 'CWinInit'
	// that will be helpful to have easy access to.
	struct WINDATA
	{
		bool								bVSync;
		bool								bFullscreen;
		bool								bResizable;
		bool								bStartMaximized;
		bool								bAllowDoubleClicks;

		char*								pIconName;
		char*								pMenuName;
		char*								pWindowTitle;

		int									posX;
		int									posY;
		int									width;
		int									height;
		int									winWidth;
		int									winHeight;

		int									minWidth;
		int									minHeight;
		int									maxWidth;
		int									maxHeight;

		RECT								clientRect;
		RECT								windowRect;

		int									bits;

		HMENU								menu;
		HINSTANCE							hInstance;
		HWND								hWnd;

		// Default constructor sets the window data varaibles to their default values.
		WINDATA()
		{
			bVSync							= true;
			bFullscreen						= false;
			bResizable						= false;
			bStartMaximized					= false;
			bAllowDoubleClicks				= false;

			pIconName						= NULL;
			pMenuName						= NULL;
			pWindowTitle					= NULL;

			posX							= 50;
			posY							= 50;
			width							= 1280;
			height							= 720;
			winWidth						= 1280;
			winHeight						= 720;

			minWidth						= 1280;
			minHeight						= 720;
			maxWidth						= 0;
			maxHeight						= 0;

			bits							= 32;

			menu							= NULL;
			hInstance						= NULL;
			hWnd							= NULL;
		}
	};
};

#endif