//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Application\CWinUtil.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CWinUtil.h"

namespace App
{
	//---------------------------------------------------------------------------------------------
	// CCursor
	//---------------------------------------------------------------------------------------------

	bool CCursor::m_bCursorHidden = false;

	// Method for centering a cursor to an inputted screen rectangle.
	void CCursor::CenterCursor(const RECT& screenRect)
	{
		SetCursorPos(
			screenRect.left + screenRect.right / 2,
			screenRect.top + screenRect.bottom / 2
		);
	}

	// Method for showing or hiding a cursor.
	void CCursor::HideCursor(bool hide)
	{
		if(hide ? m_bCursorHidden : !m_bCursorHidden)
			return;

		while((hide && ShowCursor(false) >= 0) || (!hide && ShowCursor(true) < 0)) {}

		m_bCursorHidden = hide;
	}
	
	//---------------------------------------------------------------------------------------------
	// CScreen
	//---------------------------------------------------------------------------------------------

	// Method for checking a window handle's focus.
	bool CScreen::InFocus(HWND hWnd)
	{
		return GetActiveWindow() == hWnd;
	}
};