//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Audio\CAudioList.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CAUDIOLIST_H
#define CAUDIOLIST_H

#include "CXAudio2.h"
#include "..\Math\CMathMD5.h"
#include "..\Utilities\CDataStack.h"

namespace Audio
{
	// CAudioList class (singleton)
	// Class for storing all loaded audio sources (checks for existence of audio source before creation of a new one).
	class CAudioList
	{
	public:
		struct AUDIO
		{
			char				md5[32];
			CXAudio2Source*		audioSource;
		};

	public:
		static CAudioList& Instance()
		{
			static CAudioList instance;
			return instance;
		}
		
	public:
		void								SetEngine(CXAudio2Engine* engine);

		CXAudio2Source*						AddAudioSource(const std::string& filename);
		CXAudio2Source*						FindAudioSource(const std::string& filename);

		void								Release();

	private:
		CAudioList() { m_pAudioEngine = NULL; }
		CAudioList(const CAudioList& other) = delete;
		virtual ~CAudioList() { Release(); }

		CXAudio2Engine*											m_pAudioEngine;

		Util::CStack<AUDIO>										m_sAudioStack;
	};
};

#endif