//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CDebugCircle.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CDebugCircle.h"

namespace GFX
{
	CDebugCircle::CDebugCircle()
	{
		m_b2DMode							= false;
		m_iterations						= 0;
		m_radius							= 0.0f;
	}

	CDebugCircle::CDebugCircle(const CDebugCircle& other)
	{
	}

	CDebugCircle::~CDebugCircle()
	{
	}

	// Method for setting the debug circle's data.
	void CDebugCircle::SetupCircle(float radius, bool _2dMode, u32 iterations)
	{
		m_b2DMode							= _2dMode;
		m_radius							= radius;
		m_iterations						= iterations;
	}

	// Method for initializing the debug circle's lines.
	int CDebugCircle::Initialize()
	{
		int retCode = Util::Err::NONE;

		float s0 = 0.0f;
		float c0 = m_radius;

		float s1, c1;
		float step = Math::_2Pi / m_iterations;
		float theta = step;

		// Create the circle out of lines.
		for(u32 i = 0; i < m_iterations; i++)
		{
			s1 = sinf(theta) * m_radius;
			c1 = cosf(theta) * m_radius;

			AddLine(new DEBUG_LINE(Math::CVector3(s0, m_b2DMode ? c0 : 0.0f, m_b2DMode ? 0.0f : c0), Math::CVector3(s1, m_b2DMode ? c1 : 0.0f, m_b2DMode ? 0.0f : c1)));

			s0 = s1;
			c0 = c1;

			theta += step;
		}

		if((retCode = CDebugBase::Initialize()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}
};