//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CDebugCude.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CDEBUGCUBE_H
#define CDEBUGCUBE_H

#include "CDebugBase.h"
#include "..\Math\CMathAABB.h"

namespace GFX
{
	// CDebugCube class.
	// Class for creating and rendering a line-list cube.
	class CDebugCube : public CDebugBase
	{
	public:
		CDebugCube();
		CDebugCube(const CDebugCube& other);
		virtual ~CDebugCube();

		void								CubeExtents(const Math::CVector3& min, const Math::CVector3& max);

		void								RecalculateBounds();
		int									Initialize() override;
		int									Render() override;

		inline Math::CAABB					BoundingAABB() const;
		inline Math::CVector3				MinBounds() const;
		inline Math::CVector3				MaxBounds() const;

	private:
		
		Math::CVector3						m_minBounds;
		Math::CVector3						m_maxBounds;
		Math::CVector3						m_minBoundsTransformed;
		Math::CVector3						m_maxBoundsTransformed;
		Math::CAABB							m_cubeAABB;
	};

	// Bounding AABB getter.
	inline Math::CAABB CDebugCube::BoundingAABB() const
	{
		return m_cubeAABB;
	}

	// Minimum bounds getter.
	inline Math::CVector3 CDebugCube::MinBounds() const
	{
		return m_minBoundsTransformed;
	}

	// Maximum bounds getter.
	inline Math::CVector3 CDebugCube::MaxBounds() const
	{
		return m_maxBoundsTransformed;
	}
};

#endif
