//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CDebugGrid.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CDebugGrid.h"

namespace GFX
{
	CDebugGrid::CDebugGrid()
	{
		m_b2DMode		= false;
		m_width			= 0;
		m_length		= 0;
	}
	
	CDebugGrid::CDebugGrid(const CDebugGrid& other)
	{
	}
	
	CDebugGrid::~CDebugGrid()
	{
	}
	
	// Method for setting the debug grid's data.
	void CDebugGrid::GridExtents(int width, int length, bool _2dMode)
	{
		m_b2DMode		= _2dMode;
		m_width			= width;
		m_length		= length;
	}

	// Method for initializing the debug grid's lines.
	int CDebugGrid::Initialize()
	{
		int retCode = Util::Err::NONE;
		
		int i;
		float widthHalf = (float)m_width / 2;
		float lengthHalf = (float)m_length / 2;
		Math::CVector3 pt;
		
		// Vertical lines.
		for(i = -(int)widthHalf; i <= (int)widthHalf; i++)
		{
			pt.x = (float)i; m_b2DMode ? pt.y = -lengthHalf : pt.z = -lengthHalf;
			AddLine(new DEBUG_LINE(pt, Math::CVector3(pt.x, -pt.y, -pt.z)));
		}
		
		// Horizontal lines.
		for(i = -(int)lengthHalf; i <= (int)lengthHalf; i++)
		{
			pt.x = -widthHalf; m_b2DMode ? pt.y = -(float)i : pt.z = -(float)i;
			AddLine(new DEBUG_LINE(pt, Math::CVector3(-pt.x, pt.y, pt.z)));
		}

		if((retCode = CDebugBase::Initialize()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}
};