//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CDebugSquare.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CDebugSquare.h"

namespace GFX
{
	CDebugSquare::CDebugSquare()
	{
		m_b2DMode		= false;
		m_width			= 0.0f;
		m_height		= 0.0f;
	}

	CDebugSquare::CDebugSquare(const CDebugSquare& other)
	{
	}

	CDebugSquare::~CDebugSquare()
	{
	}

	// Method for setting the debug square's data.
	void CDebugSquare::SquareExtents(float width, float height, bool _2dMode)
	{
		m_b2DMode		= _2dMode;
		m_width			= width;
		m_height		= height;
	}

	// Method for initialize the debug square's lines.
	int CDebugSquare::Initialize()
	{
		int retCode = Util::Err::NONE;

		AddLine(new DEBUG_LINE(Math::CVector3(-m_width, m_b2DMode ? -m_height : 0.0f, m_b2DMode ? 0.0f : -m_height), Math::CVector3( m_width, m_b2DMode ? -m_height : 0.0f, m_b2DMode ? 0.0f : -m_height)));
		AddLine(new DEBUG_LINE(Math::CVector3( m_width, m_b2DMode ? -m_height : 0.0f, m_b2DMode ? 0.0f : -m_height), Math::CVector3( m_width, m_b2DMode ?  m_height : 0.0f, m_b2DMode ? 0.0f :  m_height)));
		AddLine(new DEBUG_LINE(Math::CVector3( m_width, m_b2DMode ?  m_height : 0.0f, m_b2DMode ? 0.0f :  m_height), Math::CVector3(-m_width, m_b2DMode ?  m_height : 0.0f, m_b2DMode ? 0.0f :  m_height)));
		AddLine(new DEBUG_LINE(Math::CVector3(-m_width, m_b2DMode ?  m_height : 0.0f, m_b2DMode ? 0.0f :  m_height), Math::CVector3(-m_width, m_b2DMode ? -m_height : 0.0f, m_b2DMode ? 0.0f : -m_height)));

		if((retCode = CDebugBase::Initialize()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}
};