//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMatShadowMap.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATSHADOWMAP_H
#define CMATSHADOWMAP_H

#include "CMaterial.h"
#include "..\Utilities\CDataStack.h"
#include <fbxsdk.h>
#include "CTextureList.h"

#pragma comment(lib, "libfbxsdk.lib")

namespace GFX
{
	// Shadow map material constant buffer.
	struct SHADOW_CBUFFER
	{
		Math::CMatrix4x4	shadowPerspective;
	};

	// CMatShadowMap class
	// Material for creating a depth map with a (projection * view) matrix.
	class CMatShadowMap : public CMaterial
	{
	public:
		CMatShadowMap();
		CMatShadowMap(const CMatShadowMap& other);
		virtual ~CMatShadowMap();

		int									Render() override;
		void								Release() override;
		
		SHADOW_CBUFFER						m_shadowCBuffer;

	protected:
		int									SetupShader() override;
	};
};

#endif