//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CMesh.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CMesh.h"

namespace GFX
{
	CMesh::CMesh()
	{
		m_indexStride						= sizeof(u32);
		m_vertexStride						= sizeof(MESH_VERTEX);
		m_vertexPositionOffset				= 0;
		m_bCreateBoundingAABB				= true;
	}

	CMesh::CMesh(const CMesh& other)
	{
	}

	CMesh::~CMesh()
	{
	}

	// Method for initialize a mesh and for applying the correct material.
	int CMesh::Initialize()
	{
		int retCode = Util::Err::NONE;

		if(m_sMaterialStack.Length() > 0)
		{
			m_pMaterial = ((CMatMesh*)m_sMaterialStack[0]);
		}

		if((retCode = CGeoObject::Initialize()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}

	// Method for updating the mesh.
	int CMesh::Update()
	{
		int retCode = Util::Err::NONE;
		
		if((retCode = CGeoObject::Update()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}
	
	// Method for rendering the mesh.
	int CMesh::Render()
	{
		int retCode = Util::Err::NONE;
		
		if((retCode = CGeoObject::Render(true)) != Util::Err::NONE)
			return retCode;

		return retCode;
	}
	
	// Method for rendering the mesh w/ a custom material.
	int CMesh::Render(CMaterial* material)
	{
		int retCode = Util::Err::NONE;
		
		if((retCode = CGeoObject::Render(material, true)) != Util::Err::NONE)
			return retCode;

		return retCode;
	}

	// Method for releasing the mesh, and it's data.
	void CMesh::Release()
	{
		m_sMaterialStack.Release();

		CGeoObject::Release();
	}
};