//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CRenderingData.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CRENDERINGDATA_H
#define CRENDERINGDATA_H

#include "..\Math\CMathFloat.h"
#include "..\Math\CMathVector2.h"
#include "..\Math\CMathColor.h"

namespace GFX
{
	// Enumerator for the different supported fog types.
	enum class FOG_TYPE
	{
		Off,
		Linear,
		Exponential,
		Exponential2,
	};

	// Structure for storing general render data.
	struct RENDERDATA
	{
		// Class for acting as the fog constant buffer.
		class FOG_BUFFER
		{
		public:
			FOG_BUFFER()
			{
				density = 0.0f;
			}

			Math::CColor					fogColor;
			Math::CVector2					extents;
			float							density;

		private:
			float							padding0;

		} fogBuffer;

		FOG_TYPE						fogType;

		u32								geoRenderCount;
		u32								polyRenderCount;
		u32								vertRenderCount;

		RENDERDATA()
		{
			fogType						= FOG_TYPE::Off;

			geoRenderCount				= 0;
			polyRenderCount				= 0;
			vertRenderCount				= 0;
		}
	};
};

#endif