//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Graphics\CTextureProjector.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CTextureProjector.h"

namespace GFX
{
	CTextureProjector::CTextureProjector()
	{
		m_pProjectionCamera					= NULL;
	}

	CTextureProjector::CTextureProjector(const CTextureProjector& other)
	{
	}

	CTextureProjector::~CTextureProjector()
	{
	}

	// Method for initializing the texture projector.
	int CTextureProjector::Initialize()
	{
		int retCode = Util::Err::NONE;

		// Create the texture projector camera.
		m_pProjectionCamera = new Math::CCamera();

		m_pProjectionCamera->CameraMode(Math::CAMERA_MODE::Perspective);
		m_pProjectionCamera->FarView(10.0f);
		m_pProjectionCamera->NearView(0.5f);
		m_pProjectionCamera->FieldOfView(65.0f * Math::_PiOver180);
		m_pProjectionCamera->Height(1.0f);
		m_pProjectionCamera->Width(1.0f);
		m_pProjectionCamera->Initialize(1.0f);

		m_pProjectionCamera->Transform(Math::CTransformSharedPtr(new Math::CTransform()));
		m_pProjectionCamera->Transform()->Position(Math::CVector3(0, 2.0f, 0));
		m_pProjectionCamera->Transform()->Rotation(Math::CVector3(Math::_PiOver2, 0, 0));
		m_pProjectionCamera->Update();

		return retCode;
	}

	int CTextureProjector::Update()
	{
		int retCode = Util::Err::NONE;

		return retCode;
	}

	void CTextureProjector::Release()
	{
		SAFE_DELETE(m_pProjectionCamera);
	}
};