//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Math\CMathAABB.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CMathAABB.h"

namespace Math
{
	CAABB::CAABB()
	{
		
	}

	CAABB::CAABB(const CVector3& mn, const CVector3& mx)
	{
		minBounds = mn;
		maxBounds = mx;

		center.x = (minBounds.x + maxBounds.x) / 2;
		center.y = (minBounds.y + maxBounds.y) / 2;
		center.z = (minBounds.z + maxBounds.z) / 2;
	}

	CAABB::CAABB(const CVector3& mn, const CVector3& mx, const CVector3& position)
	{
		minBounds = position + mn;
		maxBounds = position + mx;

		center.x = (minBounds.x + maxBounds.x) / 2;
		center.y = (minBounds.y + maxBounds.y) / 2;
		center.z = (minBounds.z + maxBounds.z) / 2;
	}

	CAABB::CAABB(const CAABB& other)
	{
		minBounds = other.minBounds;
		maxBounds = other.maxBounds;
		center = other.center;
	}

	//
	// Conditional operators.
	//

	bool CAABB::operator ==	(const CAABB& aabb) const
	{
		return (aabb.minBounds == minBounds && aabb.maxBounds == maxBounds);
	}

	bool CAABB::operator !=	(const CAABB& aabb) const
	{
		return (aabb.minBounds != minBounds || aabb.maxBounds != maxBounds);
	}
};