//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Math\CMathAABB.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATHAABB_H
#define CMATHAABB_H

#include "CMathVector3.h"
#include "CMathFloat.h"

namespace Math
{
	// CCAABB class.
	// Class for creating an axis-aligned bounding box.
	class CAABB
	{
	public:
		CVector3 center;
		CVector3 minBounds;
		CVector3 maxBounds;

	public:
		CAABB();
		CAABB(const CVector3& mn, const CVector3& mx);
		CAABB(const CVector3& mn, const CVector3& mx, const CVector3& position);
		CAABB(const CAABB& other);

		bool operator == (const CAABB& aabb) const;
		bool operator != (const CAABB& aabb) const;
	};
};

#endif