//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Math\CMathFrustum.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATHFRUSTUM_H
#define CMATHFRUSTUM_H

#include "CMathMatrix4x4.h"
#include "CMathPlane.h"
#include "CMathAABB.h"
#include "CMathSphere.h"

namespace Math
{
	// CFrustum class.
	// Class used for creating a view frustum to assist in optimizing rendering.
	class CFrustum
	{
	public:
		CFrustum();
		
		void								Update(const CMatrix4x4& view, const CMatrix4x4& projection);
		bool								TestSphere(const CSphere& sphere);
		bool								TestAABB(const CAABB& aabb);

	private:
		CMatrix4x4*							m_pView;
		CMatrix4x4*							m_pProjection;

		CPlane								m_clipPlanes[6];
	};
};

#endif