//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Resources\Shaders\RenderUtil.hlsli
//
//-------------------------------------------------------------------------------------------------

/*
	Texture data architecture.
	----------------------------------
	t30 direction light depth map Texture2DArray
	t31 point light depth map Texture2DArray
	t32 spotlight depth map Texture2DArray

	t120 g-buffer Texture2DArray
	t121 depth buffer Texture2D
	
	----------------------------------
	----------------------------------

	Constant buffer architecture.
	----------------------------------
	b10 texture projection cbuffer
	b11 direction light cbuffer
	b12 point light cbuffer
	b13 spotlight cbuffer
*/

// Global sampler states used throughout shaders.
SamplerState	samplerAniso		: register(s0);
SamplerState	samplerAnisoClamp	: register(s1);
SamplerState	samplerLinear		: register(s2);
SamplerState	samplerLinearClamp	: register(s3);
SamplerState	samplerPoint		: register(s4);
SamplerState	samplerPointClamp	: register(s5);