//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Utilities\CScreenshot.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CScreenshot.h"

namespace Util
{
	CScreenshot::CScreenshot()
	{
	}

	CScreenshot::~CScreenshot()
	{
	}

	// Method for saving the back buffer as a screenshot file.
	int CScreenshot::Screenshot(std::wstring filename)
	{
		int retCode = Err::NONE;

		// Filename is an invalid length.
		if(filename.length() < 1)
			return retCode;

		// Filename doesn't have a valid extension (default to jpeg).
		if(filename.length() <= 4)
			filename += L".jpg";

		ID3D11Resource* resource = NULL;
		m_pDX11Data->pRenderTargetView->GetResource(&resource);
		
		// Retrieve the correct GUID format.
		GUID format = GUID_ContainerFormatPng;
		if(filename.substr(filename.length() - 4) == L".bmp")
			format = GUID_ContainerFormatBmp;
		else if(filename.substr(filename.length() - 4) == L".jpg")
			format = GUID_ContainerFormatJpeg;
		else if(filename.substr(filename.length() - 4) != L".png")
			filename += L".png";
		
		HRESULT hr;
		if(FAILED((hr = DirectX::SaveWICTextureToFile(m_pDevCon, resource, format, filename.c_str()))))
		{
			Log(std::string("Failed to save screenshot: ") + std::to_string(hr));
		}

		return retCode;
	}
};