//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Utilities\CScreenshot.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CSCREENSHOT_H
#define CSCREENSHOT_H

#include "..\Application\CDX11Object.h"
#include "CDebugError.h"
#include "CDebugLog.h"
#include <ScreenGrab.h>
#include <WICTextureLoader.h>
#include <wincodec.h>

namespace Util
{
	// CScreenshot class (singleton)
	// Class for saving the main render target as a screenshot.
	class CScreenshot : public App::CDX11Object
	{
	public:
		static CScreenshot& Instance()
		{
			static CScreenshot instance;
			return instance;
		}

	public:
		int Screenshot(std::wstring filename);

	private:
		CScreenshot();
		CScreenshot(const CScreenshot& other) = delete;
		virtual ~CScreenshot();
	};
};

#endif