//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Utilities\CSortInsertion.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CSORTINSERTION_H
#define CSORTINSERTION_H

#include "..\Globals\CGlobals.h"

namespace Util
{
	// Template function for performing an insertion sort on an array.
	template<typename T>
	void InsertionSort(T* a, u32 size, bool (*Compare) (T, T))
	{
		auto Swap = [](T& x, T& y) { T temp = x; x = y; y = temp; };

		u32 i, j;

		for(i = 1; i < size; i++)
		{
			j = i;
			while(j > 0 && Compare(a[j], a[j - 1]))
			{
				Swap(a[j], a[j - 1]);
				j--;
			}
		}
	}
};

#endif