//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Engine
//
// File: Utilities\CSortQuick.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CSORTQUICK_H
#define CSORTQUICK_H

#include "..\Globals\CGlobals.h"

namespace Util
{
	// Template function for performing an quick sort on an array.
	template<typename T>
	void QuickSort(T* a, bool (*Compare) (T, T), int left_index = 0, int right_index = 0)
	{
		if(left_index >= right_index) return;
		
		auto Swap = [](T a[], int i, int j) 
		{
			T temp = a[i];
			a[i] = a[j];
			a[j] = temp;
		};
		
		int right = right_index;
		int left = left_index;

		T pivot = a[(left_index + right_index) / 2];

		while(left <= right)
		{
			while(Compare(pivot, a[left])) left++;
			while(Compare(a[right], pivot)) right--;
			if(left <= right)
			{
				Swap(a, left, right);
				left++; right--;
			}
		}

		QuickSort(a, Compare, left_index, right);
		QuickSort(a, Compare, left, right_index);
	}
};

#endif