//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Actors\CPlayerCamera.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CPLAYERCAMERA_H
#define CPLAYERCAMERA_H

#include <Math\CMathCamera.h>
#include "..\Utilities\CGameError.h"

namespace Actor
{
	// CPlayerCamera class
	// Class the creating cameras that are used with the player object.
	class CPlayerCamera
	{
	public:
		CPlayerCamera();
		CPlayerCamera(const CPlayerCamera& other);
		virtual ~CPlayerCamera();

		int									Initialize(float screenWidth, float screenHeight);
		int									Update();

		int									PostResize(float screenWidth, float screenHeight);

		void								Release();

		inline Math::CCamera*				Camera() const;
		inline void							Camera(Math::CCamera* pCamera);
		inline Math::CCamera*				UICamera() const;
		inline void							UICamera(Math::CCamera* pUICamera);

	private:
		Math::CCamera*						m_pCamera;
		Math::CCamera*						m_pUICamera;
	};

	// Player camera getter and setter.

	inline Math::CCamera* CPlayerCamera::Camera() const
	{
		return m_pCamera;
	}

	inline void CPlayerCamera::Camera(Math::CCamera* pCamera)
	{
		m_pCamera = pCamera;
	}

	// UI camera getter and setter.

	inline Math::CCamera* CPlayerCamera::UICamera() const
	{
		return m_pUICamera;
	}

	inline void CPlayerCamera::UICamera(Math::CCamera* pUICamera)
	{
		m_pUICamera = pUICamera;
	}
};

#endif