//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Game\CGame.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CGAME_H
#define CGAME_H

#include <Utilities\CDebugLog.h>
#include <Application\CAppBase.h>
#include <Graphics\CFBXLoader.h>

#include "..\Utilities\CGameError.h"
#include "..\Scenes\CSceneMain.h"
#include "..\UI\CGameUI.h"

namespace Game
{
	// CGame class
	// Class that stores all data that is related to this game.
	class CGame : public App::CAppBase
	{
	public:
		CGame();
		CGame(const CGame& other);
		virtual ~CGame();

		int									Initialize() final;
		int									PreResize() final;
		int									PostResize() final;

		void								Release() final;

	protected:
		int									Setup() final;
		int									Update() final;
		int									Render() final;
		
		int									MessageHandler(MSG msg) final;
		
	private:
		int									Screenshot();

		GFX::CMatList*						m_pMatList;
		
		GFX::CFBXLoader*					m_pFBXLoader;

		Scene::CSceneMain*					m_pSceneMain;
		UI::CGameUI*						m_pGameUI;
	};
};

#endif