//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Graphics\CMatFireEffect.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CMATFIREEFFECT_H
#define CMATFIREEFFECT_H

#include <Graphics\CMaterial.h>
#include "..\Resources\Resources.h"

namespace GFX
{
	// Fire effect data constant buffer.
	struct FIREEFFECT_CBUFFER
	{
		Math::CColor						color;
		Math::CVector4						cameraPosition;
		Math::CVector4						speeds;
		Math::CVector4						scales;
		float								softness;
		float								time;
		float								screenWidth;
		float								screenHeight;
		int									billboardType;
		float								padding0[3];
	};

	// Fire effect distoration constant buffer.
	struct FIREEFFECT_DISTORTION
	{
		Math::CVector2						distortion0;
		Math::CVector2						distortion1;
		Math::CVector2						distortion2;
		float								distortionScale;
		float								distortionBias;
	};

	// CMatFireEffect class.
	// Class for creating a fire material used with the particle fire object.
	class CMatFireEffect : public CMaterial
	{
	public:
		CMatFireEffect();
		CMatFireEffect(const CMatFireEffect& other);
		virtual ~CMatFireEffect();

		int									Render() override;
		
		FIREEFFECT_CBUFFER					m_fireCBuffer;
		FIREEFFECT_DISTORTION				m_fireDistortion;

	protected:
		int									SetupShader() override;
	};
};

#endif