//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Scenes\CElemDebug.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CElemDebug.h"

namespace Scene
{
	CElemDebug::CElemDebug()
	{
		m_pDebugGrid						= NULL;
		m_pMatDebug							= NULL;
		m_pRenderData						= NULL;
	}

	CElemDebug::CElemDebug(const CElemDebug& other)
	{
	}

	CElemDebug::~CElemDebug()
	{
	}

	// Method for initializing the debug elements in this game.
	int CElemDebug::Initialize()
	{
		int retCode = Util::Err::NONE;

		// Allocate memory.
		m_pDebugGrid						= new GFX::CDebugGrid();
		
		// Setup debug grid.
		m_pDebugGrid->GridExtents(64, 64);
		m_pDebugGrid->Material(m_pMatDebug);
		m_pDebugGrid->RenderData(m_pRenderData);
		m_pDebugGrid->DirectXData(m_pDX11Data);

		m_pDebugGrid->Transform(Math::CTransformSharedPtr(new Math::CTransform()));
		m_pDebugGrid->Transform()->Position(Math::CVector3(0, 1.5f, 0));
		m_pDebugGrid->Transform()->Update();

		if((retCode = m_pDebugGrid->Initialize()) != Util::Err::NONE)
			return retCode;
			
		m_pDebugGrid->m_debugCBuffer.scale = Math::CVector3(0.5f, 0.5f, 0.5f);
		m_pDebugGrid->m_debugCBuffer.color = Math::CColor(1, 1, 1, 0.5f);
		
		return retCode;
	}
	
	// Method for rendering the debug elements in this game.
	int CElemDebug::Render()
	{
		int retCode = Util::Err::NONE;

		if((retCode = m_pDebugGrid->Render()) != Util::Err::NONE)
			return retCode;

		return retCode;
	}

	void CElemDebug::Release()
	{
		SAFE_RELEASE_DELETE(m_pDebugGrid);
	}
};