//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Scenes\CElemDebug.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CELEMDEBUG_H
#define CELEMDEBUG_H

#include <Application\CDX11Object.h>

#include <Graphics\CDebugGrid.h>
#include <Graphics\CDebugCube.h>
#include <Graphics\CMatDebug.h>
#include <Graphics\CRenderingData.h>

#include "..\Utilities\CGameError.h"

namespace Scene
{
	const u32 CubeCount = 3;

	// CElemDebug class.
	// Class that stores debug elements that aren't linked directly to any other objects.
	class CElemDebug : public App::CDX11Object
	{
	public:
		CElemDebug();
		CElemDebug(const CElemDebug& other);
		virtual ~CElemDebug();

		int									Initialize();
		int									Render();
		void								Release();
		
		inline GFX::RENDERDATA*				RenderData() const;
		inline void							RenderData(GFX::RENDERDATA* pRenderData);
		inline GFX::CMatDebug*				DebugMaterial() const;
		inline void							DebugMaterial(GFX::CMatDebug* pMatDebug);

	private:
		GFX::CDebugGrid*					m_pDebugGrid;
		
		GFX::RENDERDATA*					m_pRenderData;
		GFX::CMatDebug*						m_pMatDebug;
	};
	
	// Render data getter and setter.

	inline GFX::RENDERDATA* CElemDebug::RenderData() const
	{
		return m_pRenderData;
	}

	inline void CElemDebug::RenderData(GFX::RENDERDATA* pRenderData)
	{
		m_pRenderData = pRenderData;
	}

	// Debug material getter and setter.

	inline GFX::CMatDebug* CElemDebug::DebugMaterial() const
	{
		return m_pMatDebug;
	}

	inline void CElemDebug::DebugMaterial(GFX::CMatDebug* pMatDebug)
	{
		m_pMatDebug = pMatDebug;
	}
}

#endif