//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Graphics\CFlashlight.cpp
//
//-------------------------------------------------------------------------------------------------

#include "CFlashlight.h"

namespace World
{
	CFlashlight::CFlashlight()
	{
		m_pSpotlight						= NULL;
	}

	CFlashlight::CFlashlight(const CFlashlight& other)
	{
	}

	CFlashlight::~CFlashlight()
	{
	}

	// Method for initializing the flashlight.
	int CFlashlight::Initialize()
	{
		int retCode = Util::Err::NONE;

		if(!m_pTransform)
		{
			m_pTransform = Math::CTransformSharedPtr(new Math::CTransform());
			m_pTransform->Update();
		}

		return retCode;
	}

	// Method for updating the flashlight object to have the spotlight linked to it.
	int CFlashlight::Update()
	{
		int retCode = Util::Err::NONE;

		if(m_pSpotlight)
		{
			Math::CVector3 forwards = m_pTransform->Forward();
			m_pSpotlight->position = m_pTransform->Position() + forwards * 0.5f;
			m_pSpotlight->direction = Math::CVector3(forwards);
		}

		return retCode;
	}

	void CFlashlight::Release()
	{
	}
};