//-------------------------------------------------------------------------------------------------
//
// Copyright (c) 2015-2016 Ryan Alasandro
//
// Portfolio Project: Portfolio Project II
//
// File: Graphics\CFlashlight.h
//
//-------------------------------------------------------------------------------------------------

#ifndef CFLASHLIGHT_H
#define CFLASHLIGHT_H

#include <Graphics\CLighting.h>
#include "CWorldObject.h"

namespace World
{
	// CFlashlight class
	// Class for turning the flashlight object in the scene on, 
	// and for applying a spotlight with shadows to it.
	class CFlashlight : public CWorldObject
	{
	public:
		CFlashlight();
		CFlashlight(const CFlashlight& other);
		virtual ~CFlashlight();

		int									Initialize() override;
		int									Update() override;

		void								Release() override;

		inline GFX::SPOTLIGHT*				Spotlight() const;
		inline GFX::SPOTLIGHT**				ppSpotlight();
		inline void							Spotlight(GFX::SPOTLIGHT* pSpotlight);

	private:
		GFX::SPOTLIGHT*						m_pSpotlight;
	};

	// Spotlight getter and setter.

	inline GFX::SPOTLIGHT* CFlashlight::Spotlight() const
	{
		return m_pSpotlight;
	}

	inline GFX::SPOTLIGHT** CFlashlight::ppSpotlight()
	{
		return &m_pSpotlight;
	}

	inline void CFlashlight::Spotlight(GFX::SPOTLIGHT* pSpotlight)
	{
		m_pSpotlight = pSpotlight;
	}
};

#endif